// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: SpringDao.vsl in andromda-spring-cartridge.
//
package fr.ifremer.quadrige2.core.dao.sandre;

import fr.ifremer.quadrige2.core.dao.Search;
import fr.ifremer.quadrige2.core.dao.referential.taxon.TaxonomicLevel;
import java.util.Collection;
import java.util.Set;
import org.andromda.spring.PaginationResult;

/**
 * Niveaux taxinomiques Sandre pour les exports de données
 * @see SandreTaxonomicLevelExp
 */
public interface SandreTaxonomicLevelExpDao
{
    /**
     * This constant is used as a transformation flag; entities can be converted automatically into value objects
     * or other types, different methods in a class implementing this interface support this feature: look for
     * an <code>int</code> parameter called <code>transform</code>.
     * <p>
     * This specific flag denotes no transformation will occur.
     */
    public static final int TRANSFORM_NONE = 0;


    /**
     * Transforms the given results to a collection of {@link SandreTaxonomicLevelExp}
     * instances (this is useful when the returned results contains a row of data and you want just entities only).
     *
     * @param results the query results.
     */
    public void toEntities(final Collection<?> results);

    /**
     * Gets an instance of SandreTaxonomicLevelExp from the persistent store.
     * @param sandreTaxonomicLevelExpId
     * @return SandreTaxonomicLevelExp
     */
    public SandreTaxonomicLevelExp get(Integer sandreTaxonomicLevelExpId);

    /**
     * <p>
     * Does the same thing as {@link #get(Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param sandreTaxonomicLevelExpId the identifier of the entity to get.
     * @return either the entity or the object transformed from the entity.
     */
    public Object get(int transform, Integer sandreTaxonomicLevelExpId);

    /**
     * Loads an instance of SandreTaxonomicLevelExp from the persistent store.
     * @param sandreTaxonomicLevelExpId
     * @return SandreTaxonomicLevelExp
     */
    public SandreTaxonomicLevelExp load(Integer sandreTaxonomicLevelExpId);

    /**
     * <p>
     * Does the same thing as {@link #load(Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param sandreTaxonomicLevelExpId the identifier of the entity to load.
     * @return either the entity or the object transformed from the entity.
     */
    public Object load(int transform, Integer sandreTaxonomicLevelExpId);

    /**
     * Loads all entities of type {@link SandreTaxonomicLevelExp}.
     *
     * @return the loaded entities.
     */
    public Collection<SandreTaxonomicLevelExp> loadAll();

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform);

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int pageNumber, final int pageSize);

    /**
     * <p>
     * Does the same thing as {@link #loadAll(int)} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform, final int pageNumber, final int pageSize);

    /**
     * Creates an instance of SandreTaxonomicLevelExp and adds it to the persistent store.
     * @param sandreTaxonomicLevelExp
     * @return SandreTaxonomicLevelExp
     */
    public SandreTaxonomicLevelExp create(SandreTaxonomicLevelExp sandreTaxonomicLevelExp);

    /**
     * <p>
     * Does the same thing as {@link #create(SandreTaxonomicLevelExp)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param sandreTaxonomicLevelExp
     * @return Object
     */
    public Object create(int transform, SandreTaxonomicLevelExp sandreTaxonomicLevelExp);

    /**
     * Creates a new instance of SandreTaxonomicLevelExp and adds
     * from the passed in <code>entities</code> collection
     *
     * @param entities the collection of SandreTaxonomicLevelExp
     * instances to create.
     *
     * @return the created instances.
     */
    public Collection<SandreTaxonomicLevelExp> create(Collection<SandreTaxonomicLevelExp> entities);

    /**
     * <p>
     * Does the same thing as {@link #create(SandreTaxonomicLevelExp)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param entities
     * @return Collection
     */
    public Collection<?> create(int transform, Collection<SandreTaxonomicLevelExp> entities);

    /**
     * <p>
     * Creates a new <code>SandreTaxonomicLevelExp</code>
     * instance from <strong>all</strong> attributes and adds it to
     * the persistent store.
     * </p>
     * @param sandreTaxLevelId Code Sandre du niveau taxinomique
     * @param sandreTaxLevelLb Libellé Sandre du niveau taxinomique
     * @return SandreTaxonomicLevelExp
     */
    public SandreTaxonomicLevelExp create(
        Integer sandreTaxLevelId,
        String sandreTaxLevelLb);

    /**
     * <p>
     * Does the same thing as {@link #create(Integer, String)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param sandreTaxLevelId Code Sandre du niveau taxinomique
     * @param sandreTaxLevelLb Libellé Sandre du niveau taxinomique
     * @return SandreTaxonomicLevelExp
     */
    public Object create(
        int transform,
        Integer sandreTaxLevelId,
        String sandreTaxLevelLb);

    /**
     * <p>
     * Creates a new <code>SandreTaxonomicLevelExp</code>
     * instance from only <strong>required</strong> properties (attributes
     * and association ends) and adds it to the persistent store.
     * </p>
     * @param sandreTaxLevelId
     * @param taxLevelCd
     * @return SandreTaxonomicLevelExp
     */
    public SandreTaxonomicLevelExp create(
        Integer sandreTaxLevelId,
        TaxonomicLevel taxLevelCd);

    /**
     * <p>
     * Does the same thing as {@link #create(Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform flag to determine transformation type.
     * @param sandreTaxLevelId
     * @param taxLevelCd
     * @return Object
     */
    public Object create(
        int transform,
        Integer sandreTaxLevelId,
        TaxonomicLevel taxLevelCd);

    /**
     * Updates the <code>sandreTaxonomicLevelExp</code> instance in the persistent store.
     * @param sandreTaxonomicLevelExp
     */
    public void update(SandreTaxonomicLevelExp sandreTaxonomicLevelExp);

    /**
     * Updates all instances in the <code>entities</code> collection in the persistent store.
     * @param entities
     */
    public void update(Collection<SandreTaxonomicLevelExp> entities);

    /**
     * Removes the instance of SandreTaxonomicLevelExp from the persistent store.
     * @param sandreTaxonomicLevelExp
     */
    public void remove(SandreTaxonomicLevelExp sandreTaxonomicLevelExp);

    /**
     * Removes the instance of SandreTaxonomicLevelExp having the given
     * <code>identifier</code> from the persistent store.
     * @param sandreTaxonomicLevelExpId
     */
    public void remove(Integer sandreTaxonomicLevelExpId);

    /**
     * Removes all entities in the given <code>entities</code> collection.
     * @param entities
     */
    public void remove(Collection<SandreTaxonomicLevelExp> entities);


    /**
     * Does the same thing as {@link #search(int, Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param transform the transformation flag.
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int transform, final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * finder results will <strong>NOT</strong> be transformed during retrieval.
     * If this flag is any of the other constants defined here
     * then results <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     *
     * @param transform the transformation flag.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<?> search(final int transform, final Search search);

    /**
     * Performs a search using the parameters specified in the given <code>search</code> object.
     *
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<SandreTaxonomicLevelExp> search(final Search search);

    /**
     * Allows transformation of entities into value objects
     * (or something else for that matter), when the <code>transform</code>
     * flag is set to one of the constants defined in <code>fr.ifremer.quadrige2.core.dao.sandre.SandreTaxonomicLevelExpDao</code>, please note
     * that the {@link #TRANSFORM_NONE} constant denotes no transformation, so the entity itself
     * will be returned.
     *
     * If the integer argument value is unknown {@link #TRANSFORM_NONE} is assumed.
     *
     * @param transform one of the constants declared in {@link fr.ifremer.quadrige2.core.dao.sandre.SandreTaxonomicLevelExpDao}
     * @param entity an entity that was found
     * @return the transformed entity (i.e. new value object, etc)
     * @see #transformEntities(int,Collection)
     */
    public Object transformEntity(final int transform, final SandreTaxonomicLevelExp entity);

    /**
     * Transforms a collection of entities using the
     * {@link #transformEntity(int,SandreTaxonomicLevelExp)}
     * method. This method does not instantiate a new collection.
     * <p>
     * This method is to be used internally only.
     *
     * @param transform one of the constants declared in <code>fr.ifremer.quadrige2.core.dao.sandre.SandreTaxonomicLevelExpDao</code>
     * @param entities the collection of entities to transform
     * @see #transformEntity(int,SandreTaxonomicLevelExp)
     */
    public void transformEntities(final int transform, final Collection<?> entities);

    // spring-dao merge-point
}